Index: pjproject/trunk/pjlib/include/pj/pool.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/pool.h	(revision 1404)
+++ pjproject/trunk/pjlib/include/pj/pool.h	(revision 1405)
@@ -228,7 +228,7 @@
 	}
 
-	// Create the pool factory, in this case, a caching pool.
-	pj_caching_pool_init(&cp, &pj_pool_factory_default_policy, 
-			     1024*1024 );
+	// Create the pool factory, in this case, a caching pool,
+	// using default pool policy.
+	pj_caching_pool_init(&cp, NULL, 1024*1024 );
 
 	// Do a demo
@@ -506,6 +506,12 @@
 	    ((type*)pj_pool_zalloc(pool, sizeof(type)))
 
-
-
+/*
+ * Internal functions
+ */
+PJ_IDECL(void*) pj_pool_alloc_from_block(pj_pool_block *block, pj_size_t size);
+PJ_DECL(void*) pj_pool_allocate_find(pj_pool_t *pool, unsigned size);
+
+
+	
 /**
  * @}	// PJ_POOL
@@ -618,6 +624,17 @@
  *  - callback will raise PJ_NO_MEMORY_EXCEPTION exception.
  *  - access to pool factory is not serialized (i.e. not thread safe).
- */
-extern pj_pool_factory_policy pj_pool_factory_default_policy;
+ *
+ * @see pj_pool_factory_get_default_policy
+ */
+PJ_DECL_DATA(pj_pool_factory_policy) pj_pool_factory_default_policy;
+
+
+/**
+ * Get the default pool factory policy.
+ *
+ * @return the pool policy.
+ */
+PJ_DECL(const pj_pool_factory_policy*) pj_pool_factory_get_default_policy(void);
+
 
 /**
Index: pjproject/trunk/pjlib/include/pj/pool_i.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/pool_i.h	(revision 1404)
+++ pjproject/trunk/pjlib/include/pj/pool_i.h	(revision 1405)
@@ -21,5 +21,4 @@
 #include <pj/string.h>
 
-PJ_DECL(void*) pj_pool_allocate_find(pj_pool_t *pool, unsigned size);
 
 PJ_IDEF(pj_size_t) pj_pool_get_capacity( pj_pool_t *pool )
Index: pjproject/trunk/pjlib/include/pj/sock.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/sock.h	(revision 1404)
+++ pjproject/trunk/pjlib/include/pj/sock.h	(revision 1405)
@@ -60,10 +60,16 @@
  * THE LIBRARY WILL DO TRANSLATION TO THE NATIVE VALUE.
  */
-extern const pj_uint16_t PJ_AF_UNIX;    /**< Unix domain socket.	*/
-#define PJ_AF_LOCAL	 PJ_AF_UNIX;    /**< POSIX name for AF_UNIX	*/
-extern const pj_uint16_t PJ_AF_INET;    /**< Internet IP protocol.	*/
-extern const pj_uint16_t PJ_AF_INET6;   /**< IP version 6.		*/
-extern const pj_uint16_t PJ_AF_PACKET;  /**< Packet family.		*/
-extern const pj_uint16_t PJ_AF_IRDA;    /**< IRDA sockets.		*/
+extern const pj_uint16_t PJ_AF_UNIX; /**< Unix domain socket.	*/
+#define PJ_AF_LOCAL	 PJ_AF_UNIX; /**< POSIX name for AF_UNIX	*/
+extern const pj_uint16_t PJ_AF_INET; /**< Internet IP protocol.	*/
+extern const pj_uint16_t PJ_AF_INET6;/**< IP version 6.		*/
+extern const pj_uint16_t PJ_AF_PACKET;/**< Packet family.	*/
+extern const pj_uint16_t PJ_AF_IRDA; /**< IRDA sockets.		*/
+
+PJ_DECL(pj_uint16_t) pj_AF_UNIX(void);
+PJ_DECL(pj_uint16_t) pj_AF_INET(void);
+PJ_DECL(pj_uint16_t) pj_AF_INET6(void);
+PJ_DECL(pj_uint16_t) pj_AF_PACKET(void);
+PJ_DECL(pj_uint16_t) pj_AF_IRDA(void);
 
 
@@ -75,10 +81,16 @@
 
 extern const pj_uint16_t PJ_SOCK_STREAM; /**< Sequenced, reliable, connection-
-					      based byte streams.           */
+					     based byte streams.           */
 extern const pj_uint16_t PJ_SOCK_DGRAM;  /**< Connectionless, unreliable 
-					      datagrams of fixed maximum 
-					      lengths.                      */
+					     datagrams of fixed maximum 
+					     lengths.                      */
 extern const pj_uint16_t PJ_SOCK_RAW;    /**< Raw protocol interface.       */
 extern const pj_uint16_t PJ_SOCK_RDM;    /**< Reliably-delivered messages.  */
+
+
+PJ_DECL(int) pj_SOCK_STREAM(void);
+PJ_DECL(int) pj_SOCK_DGRAM(void);
+PJ_DECL(int) pj_SOCK_RAW(void);
+PJ_DECL(int) pj_SOCK_RDM(void);
 
 
@@ -94,4 +106,10 @@
 extern const pj_uint16_t PJ_SOL_IPV6;	/**< IP version 6   */
 
+PJ_DECL(pj_uint16_t) pj_SOL_SOCKET(void);
+PJ_DECL(pj_uint16_t) pj_SOL_IP(void);
+PJ_DECL(pj_uint16_t) pj_SOL_TCP(void);
+PJ_DECL(pj_uint16_t) pj_SOL_UDP(void);
+PJ_DECL(pj_uint16_t) pj_SOL_IPV6(void);
+
 
 /* IP_TOS 
@@ -103,4 +121,5 @@
 extern const pj_uint16_t PJ_IP_TOS;	/**< IP_TOS optname in setsockopt() */
 
+PJ_DECL(int) pj_IP_TOS(void);
 
 /*
@@ -115,5 +134,10 @@
 extern const pj_uint16_t PJ_IPTOS_RELIABILITY;	/**< Optimize for reliability*/
 extern const pj_uint16_t PJ_IPTOS_MINCOST;	/**< "filler data" where slow 
-						 transmission does't matter */
+						  transmission does't matter */
+
+PJ_DECL(int) pj_IPTOS_LOWDELAY(void);
+PJ_DECL(int) pj_IPTOS_THROUGHPUT(void);
+PJ_DECL(int) pj_IPTOS_RELIABILITY(void);
+PJ_DECL(int) pj_IPTOS_MINCOST(void);
 
 
@@ -122,7 +146,11 @@
  * or #pj_sock_getsockopt().
  */
-extern const pj_uint16_t PJ_SO_TYPE;    /**< Socket type.               */
-extern const pj_uint16_t PJ_SO_RCVBUF;  /**< Buffer size for receive.   */
-extern const pj_uint16_t PJ_SO_SNDBUF;  /**< Buffer size for send.      */
+extern const pj_uint16_t PJ_SO_TYPE;  /**< Socket type.             */
+extern const pj_uint16_t PJ_SO_RCVBUF;/**< Buffer size for receive. */
+extern const pj_uint16_t PJ_SO_SNDBUF;/**< Buffer size for send.    */
+
+PJ_DECL(pj_uint16_t) pj_SO_TYPE(void);
+PJ_DECL(pj_uint16_t) pj_SO_RCVBUF(void);
+PJ_DECL(pj_uint16_t) pj_SO_SNDBUF(void);
 
 
@@ -130,7 +158,11 @@
  * Flags to be specified in #pj_sock_recv, #pj_sock_send, etc.
  */
-extern const int PJ_MSG_OOB;	    /**< Out-of-band messages.		 */
-extern const int PJ_MSG_PEEK;	    /**< Peek, don't remove from buffer. */
-extern const int PJ_MSG_DONTROUTE;  /**< Don't route.			 */
+extern const int PJ_MSG_OOB;	  /**< Out-of-band messages.         */
+extern const int PJ_MSG_PEEK;	  /**< Peek, don't remove from buffer*/
+extern const int PJ_MSG_DONTROUTE;/**< Don't route.                  */
+
+PJ_DECL(int) pj_MSG_OOB(void);
+PJ_DECL(int) pj_MSG_PEEK(void);
+PJ_DECL(int) pj_MSG_DONTROUTE(void);
 
 
Index: pjproject/trunk/pjlib/include/pj/sock_select.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/sock_select.h	(revision 1404)
+++ pjproject/trunk/pjlib/include/pj/sock_select.h	(revision 1405)
@@ -65,4 +65,19 @@
  */
 PJ_DECL(void) PJ_FD_ZERO(pj_fd_set_t *fdsetp);
+
+
+/**
+ * This is an internal function, application shouldn't use this.
+ * 
+ * Get the number of descriptors in the set. This is defined in sock_select.c
+ * This function will only return the number of sockets set from PJ_FD_SET
+ * operation. When the set is modified by other means (such as by select()),
+ * the count will not be reflected here.
+ *
+ * @param fdsetp    The descriptor set.
+ *
+ * @return          Number of descriptors in the set.
+ */
+PJ_DECL(pj_size_t) PJ_FD_COUNT(const pj_fd_set_t *fdsetp);
 
 
Index: pjproject/trunk/pjlib/include/pj/timer.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/timer.h	(revision 1404)
+++ pjproject/trunk/pjlib/include/pj/timer.h	(revision 1405)
@@ -254,4 +254,7 @@
  * each of the expired timers.
  *
+ * Note: polling the timer heap is not necessary in Symbian. Please see
+ * @ref PJ_SYMBIAN_OS for more info.
+ *
  * @param ht         The timer heap.
  * @param next_delay If this parameter is not NULL, it will be filled up with
Index: pjproject/trunk/pjlib/include/pj/types.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/types.h	(revision 1404)
+++ pjproject/trunk/pjlib/include/pj/types.h	(revision 1405)
@@ -303,5 +303,9 @@
 PJ_DECL(void) pj_shutdown(void);
 
+/**
+ * Type of callback to register to pj_atexit().
+ */
 typedef void (*pj_exit_callback)(void);
+
 /**
  * Register cleanup function to be called by PJLIB when pj_shutdown() is 
Index: pjproject/trunk/pjlib/src/pj/addr_resolv_sock.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/addr_resolv_sock.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/addr_resolv_sock.c	(revision 1405)
@@ -84,5 +84,5 @@
 	int len;
 
-	status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &fd);
+	status = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &fd);
 	if (status != PJ_SUCCESS) {
 	    return status;
Index: pjproject/trunk/pjlib/src/pj/addr_resolv_symbian.cpp
===================================================================
--- pjproject/trunk/pjlib/src/pj/addr_resolv_symbian.cpp	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/addr_resolv_symbian.cpp	(revision 1405)
@@ -77,5 +77,5 @@
     he->h_name = resolved_name;
     he->h_aliases = no_aliases;
-    he->h_addrtype = PJ_AF_INET;
+    he->h_addrtype = pj_AF_INET();
     he->h_length = 4;
     he->h_addr_list = (char**) addr_list;
@@ -86,5 +86,5 @@
 
 /* Resolve the IP address of local machine */
-pj_status_t pj_gethostip(pj_in_addr *addr)
+PJ_DEF(pj_status_t) pj_gethostip(pj_in_addr *addr)
 {
     const pj_str_t *hostname = pj_gethostname();
@@ -112,5 +112,5 @@
 	int len;
 
-	status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &fd);
+	status = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &fd);
 	if (status != PJ_SUCCESS) {
 	    return status;
Index: pjproject/trunk/pjlib/src/pj/errno.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/errno.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/errno.c	(revision 1405)
@@ -102,5 +102,5 @@
 
 /* Register strerror handle. */
-PJ_DECL(pj_status_t) pj_register_strerror(pj_status_t start,
+PJ_DEF(pj_status_t) pj_register_strerror( pj_status_t start,
 					  pj_status_t space,
 					  pjsip_error_callback f)
Index: pjproject/trunk/pjlib/src/pj/fifobuf.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/fifobuf.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/fifobuf.c	(revision 1405)
@@ -26,6 +26,5 @@
 #define SZ  sizeof(unsigned)
 
-PJ_DEF(void)
-pj_fifobuf_init (pj_fifobuf_t *fifobuf, void *buffer, unsigned size)
+PJ_DEF(void) pj_fifobuf_init (pj_fifobuf_t *fifobuf, void *buffer, unsigned size)
 {
     PJ_CHECK_STACK();
@@ -41,6 +40,5 @@
 }
 
-PJ_DEF(unsigned)
-pj_fifobuf_max_size (pj_fifobuf_t *fifobuf)
+PJ_DEF(unsigned) pj_fifobuf_max_size (pj_fifobuf_t *fifobuf)
 {
     unsigned s1, s2;
@@ -58,6 +56,5 @@
 }
 
-PJ_DEF(void*)
-pj_fifobuf_alloc (pj_fifobuf_t *fifobuf, unsigned size)
+PJ_DEF(void*) pj_fifobuf_alloc (pj_fifobuf_t *fifobuf, unsigned size)
 {
     unsigned available;
@@ -116,6 +113,5 @@
 }
 
-PJ_DEF(pj_status_t)
-pj_fifobuf_unalloc (pj_fifobuf_t *fifobuf, void *buf)
+PJ_DEF(pj_status_t) pj_fifobuf_unalloc (pj_fifobuf_t *fifobuf, void *buf)
 {
     char *ptr = (char*)buf;
@@ -147,6 +143,5 @@
 }
 
-PJ_DEF(pj_status_t)
-pj_fifobuf_free (pj_fifobuf_t *fifobuf, void *buf)
+PJ_DEF(pj_status_t) pj_fifobuf_free (pj_fifobuf_t *fifobuf, void *buf)
 {
     char *ptr = (char*)buf;
Index: pjproject/trunk/pjlib/src/pj/file_io_ansi.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/file_io_ansi.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/file_io_ansi.c	(revision 1405)
@@ -110,4 +110,5 @@
 }
 
+/*
 PJ_DEF(pj_bool_t) pj_file_eof(pj_oshandle_t fd, enum pj_file_access access)
 {
@@ -115,4 +116,5 @@
     return feof((FILE*)fd) ? PJ_TRUE : 0;
 }
+*/
 
 PJ_DEF(pj_status_t) pj_file_setpos( pj_oshandle_t fd,
Index: pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c	(revision 1405)
@@ -101,8 +101,8 @@
      */
     optlen = sizeof(key->fd_type);
-    rc = pj_sock_getsockopt(sock, PJ_SOL_SOCKET, PJ_SO_TYPE,
+    rc = pj_sock_getsockopt(sock, pj_SOL_SOCKET(), pj_SO_TYPE(),
                             &key->fd_type, &optlen);
     if (rc != PJ_SUCCESS)
-        key->fd_type = PJ_SOCK_STREAM;
+        key->fd_type = pj_SOCK_STREAM();
 
     /* Create mutex for the key. */
@@ -270,5 +270,5 @@
          * so that send() can work in parallel.
          */
-        if (h->fd_type == PJ_SOCK_DGRAM) {
+        if (h->fd_type == pj_SOCK_DGRAM()) {
             pj_list_erase(write_op);
 
@@ -316,10 +316,10 @@
         if (send_rc!=PJ_SUCCESS || 
             write_op->written == (pj_ssize_t)write_op->size ||
-            h->fd_type == PJ_SOCK_DGRAM) 
+            h->fd_type == pj_SOCK_DGRAM()) 
         {
 
 	    write_op->op = PJ_IOQUEUE_OP_NONE;
 
-            if (h->fd_type != PJ_SOCK_DGRAM) {
+            if (h->fd_type != pj_SOCK_DGRAM()) {
                 /* Write completion of the whole stream. */
                 pj_list_erase(write_op);
Index: pjproject/trunk/pjlib/src/pj/ioqueue_select.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/ioqueue_select.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/ioqueue_select.c	(revision 1405)
@@ -64,20 +64,4 @@
 #   error "Error reporting must be enabled for this function to work!"
 #endif
-
-/**
- * Get the number of descriptors in the set. This is defined in sock_select.c
- * This function will only return the number of sockets set from PJ_FD_SET
- * operation. When the set is modified by other means (such as by select()),
- * the count will not be reflected here.
- *
- * That's why don't export this function in the header file, to avoid
- * misunderstanding.
- *
- * @param fdsetp    The descriptor set.
- *
- * @return          Number of descriptors in the set.
- */
-PJ_DECL(pj_size_t) PJ_FD_COUNT(const pj_fd_set_t *fdsetp);
-
 
 /*
Index: pjproject/trunk/pjlib/src/pj/ioqueue_winnt.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/ioqueue_winnt.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/ioqueue_winnt.c	(revision 1405)
@@ -1107,5 +1107,5 @@
     op_key_rec = (union operation_key*)op_key->internal__;
     
-    status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_STREAM, 0, 
+    status = pj_sock_socket(pj_AF_INET(), pj_SOCK_STREAM(), 0, 
                             &op_key_rec->accept.newsock);
     if (status != PJ_SUCCESS)
Index: pjproject/trunk/pjlib/src/pj/log.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/log.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/log.c	(revision 1405)
@@ -25,5 +25,9 @@
 #if PJ_LOG_MAX_LEVEL >= 1
 
-PJ_DEF(int) pj_log_max_level = PJ_LOG_MAX_LEVEL;
+#if 0
+PJ_DEF_DATA(int) pj_log_max_level = PJ_LOG_MAX_LEVEL;
+#else
+static int pj_log_max_level = PJ_LOG_MAX_LEVEL;
+#endif
 static pj_log_func *log_writer = &pj_log_write;
 static unsigned log_decor = PJ_LOG_HAS_TIME | PJ_LOG_HAS_MICRO_SEC |
@@ -49,5 +53,5 @@
 }
 
-#if 0
+#if 1
 PJ_DEF(int) pj_log_get_level(void)
 {
@@ -170,4 +174,5 @@
 }
 
+/*
 PJ_DEF(void) pj_log_0(const char *obj, const char *format, ...)
 {
@@ -177,4 +182,5 @@
     va_end(arg);
 }
+*/
 
 PJ_DEF(void) pj_log_1(const char *obj, const char *format, ...)
Index: pjproject/trunk/pjlib/src/pj/os_core_symbian.cpp
===================================================================
--- pjproject/trunk/pjlib/src/pj/os_core_symbian.cpp	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/os_core_symbian.cpp	(revision 1405)
@@ -261,6 +261,4 @@
 
 
-PJ_DECL(void) pj_shutdown(void);
-
 /*
  * pj_init(void).
@@ -332,4 +330,92 @@
     PjSymbianOS *os = PjSymbianOS::Instance();
     os->Shutdown();
+}
+
+/////////////////////////////////////////////////////////////////////////////
+
+class CPollTimeoutTimer : public CActive 
+{
+public:
+    static CPollTimeoutTimer* NewL(int msec, TInt prio);
+    ~CPollTimeoutTimer();
+    
+    virtual void RunL();
+    virtual void DoCancel();
+
+private:	
+    RTimer	     rtimer_;
+    
+    explicit CPollTimeoutTimer(TInt prio);
+    void ConstructL(int msec);
+};
+
+CPollTimeoutTimer::CPollTimeoutTimer(TInt prio)
+: CActive(prio)
+{
+}
+
+
+CPollTimeoutTimer::~CPollTimeoutTimer() 
+{
+    rtimer_.Close();
+}
+
+void CPollTimeoutTimer::ConstructL(int msec) 
+{
+    rtimer_.CreateLocal();
+    CActiveScheduler::Add(this);
+    rtimer_.After(iStatus, msec*1000);
+    SetActive();
+}
+
+CPollTimeoutTimer* CPollTimeoutTimer::NewL(int msec, TInt prio) 
+{
+    CPollTimeoutTimer *self = new CPollTimeoutTimer(prio);
+    CleanupStack::PushL(self);
+    self->ConstructL(msec);    
+    CleanupStack::Pop(self);
+
+    return self;
+}
+
+void CPollTimeoutTimer::RunL() 
+{
+}
+
+void CPollTimeoutTimer::DoCancel() 
+{
+     rtimer_.Cancel();
+}
+
+
+/*
+ * Wait the completion of any Symbian active objects. 
+ */
+PJ_DEF(pj_bool_t) pj_symbianos_poll(int priority, int ms_timeout)
+{
+    CPollTimeoutTimer *timer = NULL;
+    
+    if (priority==-1)
+    	priority = CActive::EPriorityStandard;
+    
+    if (ms_timeout >= 0) {
+    	timer = CPollTimeoutTimer::NewL(ms_timeout, priority);
+    }
+    
+    PjSymbianOS::Instance()->WaitForActiveObjects(priority);
+    
+    if (timer) {
+        bool timer_is_active = timer->IsActive();
+    
+        if (timer_is_active)
+            timer->Cancel();
+        
+        delete timer;
+        
+    	return timer_is_active ? PJ_TRUE : PJ_FALSE;
+    	
+    } else {
+    	return PJ_TRUE;
+    }
 }
 
Index: pjproject/trunk/pjlib/src/pj/os_symbian.h
===================================================================
--- pjproject/trunk/pjlib/src/pj/os_symbian.h	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/os_symbian.h	(revision 1405)
@@ -221,5 +221,5 @@
     {
 	pj_bzero(&pj_addr, sizeof(pj_sockaddr_in));
-	pj_addr.sin_family = PJ_AF_INET;
+	pj_addr.sin_family = pj_AF_INET();
 	pj_addr.sin_addr.s_addr = pj_htonl(sym_addr.Address());
 	pj_addr.sin_port = pj_htons((pj_uint16_t) sym_addr.Port());
Index: pjproject/trunk/pjlib/src/pj/os_time_common.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/os_time_common.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/os_time_common.c	(revision 1405)
@@ -19,4 +19,6 @@
 #include <pj/os.h>
 #include <pj/compat/time.h>
+#include <pj/errno.h>
+
 
 ///////////////////////////////////////////////////////////////////////////////
@@ -66,10 +68,18 @@
  * Convert local time to GMT.
  */
-PJ_DEF(pj_status_t) pj_time_local_to_gmt(pj_time_val *tv);
+PJ_DEF(pj_status_t) pj_time_local_to_gmt(pj_time_val *tv)
+{
+    PJ_UNUSED_ARG(tv);
+    return PJ_EBUG;
+}
 
 /**
  * Convert GMT to local time.
  */
-PJ_DEF(pj_status_t) pj_time_gmt_to_local(pj_time_val *tv);
+PJ_DEF(pj_status_t) pj_time_gmt_to_local(pj_time_val *tv)
+{
+    PJ_UNUSED_ARG(tv);
+    return PJ_EBUG;
+}
 
 
Index: pjproject/trunk/pjlib/src/pj/pool_caching.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/pool_caching.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/pool_caching.c	(revision 1405)
@@ -66,4 +66,8 @@
 	pj_list_init(&cp->free_list[i]);
 
+    if (policy == NULL) {
+    	policy = &pj_pool_factory_default_policy;
+    }
+    
     pj_memcpy(&cp->factory.policy, policy, sizeof(pj_pool_factory_policy));
     cp->factory.create_pool = &cpool_create_pool;
Index: pjproject/trunk/pjlib/src/pj/pool_policy_kmalloc.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/pool_policy_kmalloc.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/pool_policy_kmalloc.c	(revision 1405)
@@ -57,2 +57,7 @@
 };
 
+PJ_DEF(const pj_pool_factory_policy*) pj_pool_factory_get_default_policy(void)
+{
+    return &pj_pool_factory_default_policy;
+}
+
Index: pjproject/trunk/pjlib/src/pj/pool_policy_malloc.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/pool_policy_malloc.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/pool_policy_malloc.c	(revision 1405)
@@ -87,5 +87,5 @@
 }
 
-pj_pool_factory_policy pj_pool_factory_default_policy = 
+PJ_DECL_DATA(pj_pool_factory_policy) pj_pool_factory_default_policy =
 {
     &default_block_alloc,
@@ -95,3 +95,9 @@
 };
 
+PJ_DEF(const pj_pool_factory_policy*) pj_pool_factory_get_default_policy(void)
+{
+    return &pj_pool_factory_default_policy;
+}
+
+
 #endif	/* PJ_HAS_POOL_ALT_API */
Index: pjproject/trunk/pjlib/src/pj/pool_policy_new.cpp
===================================================================
--- pjproject/trunk/pjlib/src/pj/pool_policy_new.cpp	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/pool_policy_new.cpp	(revision 1405)
@@ -78,5 +78,5 @@
 }
 
-pj_pool_factory_policy pj_pool_factory_default_policy = 
+PJ_DEF_DATA(pj_pool_factory_policy) pj_pool_factory_default_policy = 
 {
     &operator_new,
@@ -85,11 +85,11 @@
     0
 };
- 
-PJ_DEF(pj_pool_factory_policy*) pj_pool_factory_get_default_policy(void)
+
+PJ_DEF(const pj_pool_factory_policy*) pj_pool_factory_get_default_policy(void)
 {
     return &pj_pool_factory_default_policy;
 }
 
-
+ 
 #endif	/* PJ_HAS_POOL_ALT_API */
 
Index: pjproject/trunk/pjlib/src/pj/sock_common.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/sock_common.c	(revision 1405)
+++ pjproject/trunk/pjlib/src/pj/sock_common.c	(revision 1405)
@@ -0,0 +1,145 @@
+/* $Id$ */
+/* 
+ * Copyright (C)2003-2007 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#include <pj/sock.h>
+
+PJ_DEF(pj_uint16_t) pj_AF_UNIX(void)
+{
+    return PJ_AF_UNIX;
+}
+
+PJ_DEF(pj_uint16_t) pj_AF_INET(void)
+{
+    return PJ_AF_INET;
+}
+
+PJ_DEF(pj_uint16_t) pj_AF_INET6(void)
+{
+    return PJ_AF_INET6;
+}
+
+PJ_DEF(pj_uint16_t) pj_AF_PACKET(void)
+{
+    return PJ_AF_PACKET;
+}
+
+PJ_DEF(pj_uint16_t) pj_AF_IRDA(void)
+{
+    return PJ_AF_IRDA;
+}
+
+PJ_DEF(int) pj_SOCK_STREAM(void)
+{
+    return PJ_SOCK_STREAM;
+}
+
+PJ_DEF(int) pj_SOCK_DGRAM(void)
+{
+    return PJ_SOCK_DGRAM;
+}
+
+PJ_DEF(int) pj_SOCK_RAW(void)
+{
+    return PJ_SOCK_RAW;
+}
+
+PJ_DEF(int) pj_SOCK_RDM(void)
+{
+    return PJ_SOCK_RDM;
+}
+
+PJ_DEF(pj_uint16_t) pj_SOL_SOCKET(void)
+{
+    return PJ_SOL_SOCKET;
+}
+
+PJ_DEF(pj_uint16_t) pj_SOL_IP(void)
+{
+    return PJ_SOL_IP;
+}
+
+PJ_DEF(pj_uint16_t) pj_SOL_TCP(void)
+{
+    return PJ_SOL_TCP;
+}
+
+PJ_DEF(pj_uint16_t) pj_SOL_UDP(void)
+{
+    return PJ_SOL_UDP;
+}
+
+PJ_DEF(pj_uint16_t) pj_SOL_IPV6(void)
+{
+    return PJ_SOL_IPV6;
+}
+
+PJ_DEF(int) pj_IP_TOS(void)
+{
+    return PJ_IP_TOS;
+}
+
+PJ_DEF(int) pj_IPTOS_LOWDELAY(void)
+{
+    return PJ_IPTOS_LOWDELAY;
+}
+
+PJ_DEF(int) pj_IPTOS_THROUGHPUT(void)
+{
+    return PJ_IPTOS_THROUGHPUT;
+}
+
+PJ_DEF(int) pj_IPTOS_RELIABILITY(void)
+{
+    return PJ_IPTOS_RELIABILITY;
+}
+
+PJ_DEF(int) pj_IPTOS_MINCOST(void)
+{
+    return PJ_IPTOS_MINCOST;
+}
+
+PJ_DEF(pj_uint16_t) pj_SO_TYPE(void)
+{
+    return PJ_SO_TYPE;
+}
+
+PJ_DEF(pj_uint16_t) pj_SO_RCVBUF(void)
+{
+    return PJ_SO_RCVBUF;
+}
+
+PJ_DEF(pj_uint16_t) pj_SO_SNDBUF(void)
+{
+    return PJ_SO_SNDBUF;
+}
+
+PJ_DEF(int) pj_MSG_OOB(void)
+{
+    return PJ_MSG_OOB;
+}
+
+PJ_DEF(int) pj_MSG_PEEK(void)
+{
+    return PJ_MSG_PEEK;
+}
+
+PJ_DEF(int) pj_MSG_DONTROUTE(void)
+{
+    return PJ_MSG_DONTROUTE;
+}
+
Index: pjproject/trunk/pjlib/src/pj/sock_symbian.cpp
===================================================================
--- pjproject/trunk/pjlib/src/pj/sock_symbian.cpp	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/sock_symbian.cpp	(revision 1405)
@@ -53,4 +53,11 @@
 const pj_uint16_t PJ_SOL_IPV6	= 0xFFFF;
 
+/* TOS */
+const pj_uint16_t PJ_IP_TOS		= 0;
+const pj_uint16_t PJ_IPTOS_LOWDELAY	= 0;
+const pj_uint16_t PJ_IPTOS_THROUGHPUT	= 0;
+const pj_uint16_t PJ_IPTOS_RELIABILITY	= 0;
+const pj_uint16_t PJ_IPTOS_MINCOST	= 0;
+
 /* ioctl() is also not supported. */
 const pj_uint16_t PJ_SO_TYPE    = 0xFFFF;
@@ -58,4 +65,8 @@
 const pj_uint16_t PJ_SO_SNDBUF  = 0xFFFF;
 
+/* Flags */
+const int PJ_MSG_OOB	     = 0;
+const int PJ_MSG_PEEK	     = KSockReadPeek;
+const int PJ_MSG_DONTROUTE   = 0;
 
 /////////////////////////////////////////////////////////////////////////////
@@ -456,7 +467,7 @@
     /* Set proto if none is specified. */
     if (proto == 0) {
-	if (type == PJ_SOCK_STREAM)
+	if (type == pj_SOCK_STREAM())
 	    proto = KProtocolInetTcp;
-	else if (type == PJ_SOCK_DGRAM)
+	else if (type == pj_SOCK_DGRAM())
 	    proto = KProtocolInetUdp;
     }
Index: pjproject/trunk/pjlib/src/pj/types.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/types.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pj/types.c	(revision 1405)
@@ -20,5 +20,5 @@
 #include <pj/os.h>
 
-void pj_time_val_normalize(pj_time_val *t)
+PJ_DEF(void) pj_time_val_normalize(pj_time_val *t)
 {
     PJ_CHECK_STACK();
Index: pjproject/trunk/pjlib/src/pjlib-test/echo_clt.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/echo_clt.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pjlib-test/echo_clt.c	(revision 1405)
@@ -66,5 +66,5 @@
     unsigned counter = 0;
 
-    rc = app_socket(PJ_AF_INET, client->sock_type, 0, -1, &sock);
+    rc = app_socket(pj_AF_INET(), client->sock_type, 0, -1, &sock);
     if (rc != PJ_SUCCESS) {
         app_perror("...unable to create socket", rc);
Index: pjproject/trunk/pjlib/src/pjlib-test/ioq_perf.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/ioq_perf.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pjlib-test/ioq_perf.c	(revision 1405)
@@ -276,5 +276,5 @@
         /* Create socket pair. */
 	TRACE_((THIS_FILE, "      calling socketpair.."));
-        rc = app_socketpair(PJ_AF_INET, sock_type, 0, 
+        rc = app_socketpair(pj_AF_INET(), sock_type, 0, 
                             &items[i].server_fd, &items[i].client_fd);
         if (rc != PJ_SUCCESS) {
@@ -452,47 +452,47 @@
     } test_param[] = 
     {
-        { PJ_SOCK_DGRAM, "udp", 1, 1},
-        { PJ_SOCK_DGRAM, "udp", 1, 2},
-        { PJ_SOCK_DGRAM, "udp", 1, 4},
-        { PJ_SOCK_DGRAM, "udp", 1, 8},
-        { PJ_SOCK_DGRAM, "udp", 2, 1},
-        { PJ_SOCK_DGRAM, "udp", 2, 2},
-        { PJ_SOCK_DGRAM, "udp", 2, 4},
-        { PJ_SOCK_DGRAM, "udp", 2, 8},
-        { PJ_SOCK_DGRAM, "udp", 4, 1},
-        { PJ_SOCK_DGRAM, "udp", 4, 2},
-        { PJ_SOCK_DGRAM, "udp", 4, 4},
-        { PJ_SOCK_DGRAM, "udp", 4, 8},
-        { PJ_SOCK_DGRAM, "udp", 4, 16},
-        { PJ_SOCK_STREAM, "tcp", 1, 1},
-        { PJ_SOCK_STREAM, "tcp", 1, 2},
-        { PJ_SOCK_STREAM, "tcp", 1, 4},
-        { PJ_SOCK_STREAM, "tcp", 1, 8},
-        { PJ_SOCK_STREAM, "tcp", 2, 1},
-        { PJ_SOCK_STREAM, "tcp", 2, 2},
-        { PJ_SOCK_STREAM, "tcp", 2, 4},
-        { PJ_SOCK_STREAM, "tcp", 2, 8},
-        { PJ_SOCK_STREAM, "tcp", 4, 1},
-        { PJ_SOCK_STREAM, "tcp", 4, 2},
-        { PJ_SOCK_STREAM, "tcp", 4, 4},
-        { PJ_SOCK_STREAM, "tcp", 4, 8},
-        { PJ_SOCK_STREAM, "tcp", 4, 16},
+        { pj_SOCK_DGRAM(), "udp", 1, 1},
+        { pj_SOCK_DGRAM(), "udp", 1, 2},
+        { pj_SOCK_DGRAM(), "udp", 1, 4},
+        { pj_SOCK_DGRAM(), "udp", 1, 8},
+        { pj_SOCK_DGRAM(), "udp", 2, 1},
+        { pj_SOCK_DGRAM(), "udp", 2, 2},
+        { pj_SOCK_DGRAM(), "udp", 2, 4},
+        { pj_SOCK_DGRAM(), "udp", 2, 8},
+        { pj_SOCK_DGRAM(), "udp", 4, 1},
+        { pj_SOCK_DGRAM(), "udp", 4, 2},
+        { pj_SOCK_DGRAM(), "udp", 4, 4},
+        { pj_SOCK_DGRAM(), "udp", 4, 8},
+        { pj_SOCK_DGRAM(), "udp", 4, 16},
+        { pj_SOCK_STREAM(), "tcp", 1, 1},
+        { pj_SOCK_STREAM(), "tcp", 1, 2},
+        { pj_SOCK_STREAM(), "tcp", 1, 4},
+        { pj_SOCK_STREAM(), "tcp", 1, 8},
+        { pj_SOCK_STREAM(), "tcp", 2, 1},
+        { pj_SOCK_STREAM(), "tcp", 2, 2},
+        { pj_SOCK_STREAM(), "tcp", 2, 4},
+        { pj_SOCK_STREAM(), "tcp", 2, 8},
+        { pj_SOCK_STREAM(), "tcp", 4, 1},
+        { pj_SOCK_STREAM(), "tcp", 4, 2},
+        { pj_SOCK_STREAM(), "tcp", 4, 4},
+        { pj_SOCK_STREAM(), "tcp", 4, 8},
+        { pj_SOCK_STREAM(), "tcp", 4, 16},
 /*
-	{ PJ_SOCK_DGRAM, "udp", 32, 1},
-	{ PJ_SOCK_DGRAM, "udp", 32, 1},
-	{ PJ_SOCK_DGRAM, "udp", 32, 1},
-	{ PJ_SOCK_DGRAM, "udp", 32, 1},
-	{ PJ_SOCK_DGRAM, "udp", 1, 32},
-	{ PJ_SOCK_DGRAM, "udp", 1, 32},
-	{ PJ_SOCK_DGRAM, "udp", 1, 32},
-	{ PJ_SOCK_DGRAM, "udp", 1, 32},
-	{ PJ_SOCK_STREAM, "tcp", 32, 1},
-	{ PJ_SOCK_STREAM, "tcp", 32, 1},
-	{ PJ_SOCK_STREAM, "tcp", 32, 1},
-	{ PJ_SOCK_STREAM, "tcp", 32, 1},
-	{ PJ_SOCK_STREAM, "tcp", 1, 32},
-	{ PJ_SOCK_STREAM, "tcp", 1, 32},
-	{ PJ_SOCK_STREAM, "tcp", 1, 32},
-	{ PJ_SOCK_STREAM, "tcp", 1, 32},
+	{ pj_SOCK_DGRAM(), "udp", 32, 1},
+	{ pj_SOCK_DGRAM(), "udp", 32, 1},
+	{ pj_SOCK_DGRAM(), "udp", 32, 1},
+	{ pj_SOCK_DGRAM(), "udp", 32, 1},
+	{ pj_SOCK_DGRAM(), "udp", 1, 32},
+	{ pj_SOCK_DGRAM(), "udp", 1, 32},
+	{ pj_SOCK_DGRAM(), "udp", 1, 32},
+	{ pj_SOCK_DGRAM(), "udp", 1, 32},
+	{ pj_SOCK_STREAM(), "tcp", 32, 1},
+	{ pj_SOCK_STREAM(), "tcp", 32, 1},
+	{ pj_SOCK_STREAM(), "tcp", 32, 1},
+	{ pj_SOCK_STREAM(), "tcp", 32, 1},
+	{ pj_SOCK_STREAM(), "tcp", 1, 32},
+	{ pj_SOCK_STREAM(), "tcp", 1, 32},
+	{ pj_SOCK_STREAM(), "tcp", 1, 32},
+	{ pj_SOCK_STREAM(), "tcp", 1, 32},
 */
     };
